#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # 2A.algo - Puzzles algorithmiques (2)
# 
# Puzzles algorithmiques tirés de [Google Code Jam](https://code.google.com/codejam/) et autres sites équivalents, nombres premiers, écoulement d'eau, séparation des bagarreurs, formation de binômes.

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ## Exercice 1 : nombres premiers
# 
# [CodeForces 483A](http://codeforces.com/problemset/problem/483/A)
# 
# On propose la conjecture suivante :
#     
# Si $(a,b)$ sont premiers entre eux et si $(b,c)$ sont premiers entre eux alors $(a,c)$ sont premiers entre eux.
# 
# On veut montrer que cette conjecture est **fausse**. Pour cela, il faut trouver trois entiers $(a,b,c)$ pour lesquels l'énoncé est faux et on les cherche tels qu'il existe deux entiers $l<r$ :
# 
# * $l \leqslant a < b < c \leqslant r$
# * $1 \leqslant l \leqslant r  \leqslant  10^{18}$
# * $r - l \leqslant 50$

# In[2]:





# ## Exercice 2 : watersheds
# 
# [Google Code Jam 2009](https://code.google.com/codejam/contest/90101/dashboard#s=p1)
#                        
# Geologists sometimes divide an area of land into different regions based on where rainfall flows down to. These regions are called drainage basins.
# 
# Given an elevation map (a 2-dimensional array of altitudes), label the map such that locations in the same drainage basin have the same label, subject to the following rules.
# 
# * From each cell, water flows down to at most one of its 4 neighboring cells.
# * For each cell, if none of its 4 neighboring cells has a lower altitude than the current cell's, then the water does not flow, and the current cell is called a sink.
# * Otherwise, water flows from the current cell to the neighbor with the lowest altitude.
# *  In case of a tie, water will choose the first direction with the lowest altitude from this list: North, West, East, South.
# 
# Every cell that drains directly or indirectly to the same sink is part of the same drainage basin. Each basin is labeled by a unique lower-case letter, in such a way that, when the rows of the map are concatenated from top to bottom, the resulting string is lexicographically smallest. (In particular, the basin of the most North-Western cell is always labeled 'a'.)

# In[3]:





# ## Exercice 3 : séparation des bagarreurs
# 
# [Google Code Jam 2014](https://code.google.com/codejam/contest/2933486/dashboard#s=p0)
# 
# As the leader of the Evil League of Evil, Bad Horse has a lot of problems to deal with. Most recently, there have been far too many arguments and far too much backstabbing in the League, so much so that Bad Horse has decided to split the league into two departments in order to separate troublesome members. Being the Thoroughbred of Sin, Bad Horse isn't about to spend his valuable time figuring out how to split the League members by himself. That what he's got you -- his loyal henchman -- for.

# In[4]:





# ## Exercice 4 : formation de binômes
# 
# [UVa 10911](http://uva.onlinejudge.org/index.php?option=onlinejudge&page=show_problem&problem=1852)
# 
# You have been given the job of forming the quiz teams for the next 'MCA CPCI Quiz Championship'. There are $2N$ students interested to participate and you have to form $N$ teams, each team consisting of two members. Since the members have to practice together, all the students want their member's house as near as possible. Let $x_1$ be the distance between the houses of group 1, $x_2$ be the distance between the houses of group 2 and so on. You have to make sure the summation ($x_1 + x_2 + x_3 + ... + x_n$) is minimized.
# 

# In[5]: